--- src/lib-sieve/plugins/vacation/cmd-vacation.c.orig	2022-12-21 09:50:02.000000000 +0100
+++ src/lib-sieve/plugins/vacation/cmd-vacation.c	2023-02-11 03:02:35.274330000 +0100
@@ -948,7 +948,7 @@
 }
 
 static bool
-_header_get_full_reply_recipient(const struct ext_vacation_config *config,
+_header_get_full_reply_recipient(bool ignore_envelope,
 				 const struct smtp_address *smtp_to,
 				 const char *header,
 				 struct message_address *reply_to_r)
@@ -961,7 +961,7 @@
 		strlen(header), 256, 0);
 
 	for (; addr != NULL; addr = addr->next) {
-		bool matched = config->to_header_ignore_envelope;
+		bool matched = ignore_envelope;
 
 		if (addr->domain == NULL || addr->invalid_syntax)
 			continue;
@@ -979,7 +979,7 @@
 
 static int
 _get_full_reply_recipient(const struct sieve_action_exec_env *aenv,
-			  const struct ext_vacation_config *config,
+			  bool ignore_envelope,
 			  const struct smtp_address *smtp_to,
 			  struct message_address *reply_to_r)
 {
@@ -1001,7 +1001,7 @@
 		if (ret == 0 || header == NULL)
 			continue;
 
-		if (_header_get_full_reply_recipient(config, smtp_to,
+		if (_header_get_full_reply_recipient(ignore_envelope, smtp_to,
 						     header, reply_to_r))
 			return SIEVE_EXEC_OK;
 	}
@@ -1107,13 +1107,19 @@
 	i_zero(&reply_to);
 	reply_to.mailbox = smtp_to->localpart;
 	reply_to.domain = smtp_to->domain;
-	if ((ret = _get_full_reply_recipient(aenv, config, smtp_to,
+	char *chk = strstr(smtp_to->domain, ".amazonses.com");
+	bool ignore_envelope = (chk && chk[14] == '\0');
+	if ((ret = _get_full_reply_recipient(aenv, ignore_envelope || config->to_header_ignore_envelope, smtp_to,
 					     &reply_to)) <= 0)
 		return ret;
 
 	/* Open smtp session */
 
-	sctx = sieve_smtp_start_single(senv, smtp_to, smtp_from, &output);
+	struct smtp_address real_to;
+	if (ignore_envelope && smtp_address_init_from_msg(&real_to, &reply_to) >= 0)
+		sctx = sieve_smtp_start_single(senv, &real_to, smtp_from, &output);
+	else
+		sctx = sieve_smtp_start_single(senv, smtp_to, smtp_from, &output);
 
 	outmsgid = sieve_message_get_new_id(eenv->svinst);
 
